// **********************************************************************
//
// Copyright (c) 2003-2006 ZeroC, Inc. All rights reserved.
//
// This copy of Ice-E is licensed to you under the terms described in the
// ICEE_LICENSE file included in this distribution.
//
// **********************************************************************

// Ice-E version 1.1.0

package Demo;

public final class HelloPrxHelper extends Ice.ObjectPrxHelperBase implements HelloPrx
{
    public void
    sayHello()
    {
	sayHello(__defaultContext());
    }

    public void
    sayHello(java.util.Hashtable __ctx)
    {
	int __cnt = 0;
	while(true)
	{
	    try
	    {
		Ice.Connection __connection = ice_connection();
		IceInternal.Outgoing __og = __connection.getOutgoing(_reference, "sayHello", Ice.OperationMode.Nonmutating, __ctx);
		try
		{
		    boolean __ok = __og.invoke();
		    try
		    {
			IceInternal.BasicStream __is = __og.stream();
			if(!__ok)
			{
			    try
			    {
				__is.throwException();
			    }
			    catch(Ice.UserException __ex)
			    {
				Ice.UnknownUserException __uex = new Ice.UnknownUserException();
				__uex.unknown = __ex.ice_name();
				throw __uex;
			    }
			}
		    }
		    catch(Ice.LocalException __ex)
		    {
			throw new IceInternal.LocalExceptionWrapper(__ex, false);
		    }
		}
		finally
		{
		    __connection.reclaimOutgoing(__og);
		}
		return ;
	    }
	    catch(IceInternal.LocalExceptionWrapper __ex)
	    {
		__cnt = __handleExceptionWrapperRelaxed(__ex, __cnt);
	    }
	    catch(Ice.LocalException __ex)
	    {
		__cnt = __handleException(__ex, __cnt);
	    }
	}
    }

    public void
    shutdown()
    {
	shutdown(__defaultContext());
    }

    public void
    shutdown(java.util.Hashtable __ctx)
    {
	int __cnt = 0;
	while(true)
	{
	    try
	    {
		Ice.Connection __connection = ice_connection();
		IceInternal.Outgoing __og = __connection.getOutgoing(_reference, "shutdown", Ice.OperationMode.Idempotent, __ctx);
		try
		{
		    boolean __ok = __og.invoke();
		    try
		    {
			IceInternal.BasicStream __is = __og.stream();
			if(!__ok)
			{
			    try
			    {
				__is.throwException();
			    }
			    catch(Ice.UserException __ex)
			    {
				Ice.UnknownUserException __uex = new Ice.UnknownUserException();
				__uex.unknown = __ex.ice_name();
				throw __uex;
			    }
			}
		    }
		    catch(Ice.LocalException __ex)
		    {
			throw new IceInternal.LocalExceptionWrapper(__ex, false);
		    }
		}
		finally
		{
		    __connection.reclaimOutgoing(__og);
		}
		return ;
	    }
	    catch(IceInternal.LocalExceptionWrapper __ex)
	    {
		__cnt = __handleExceptionWrapperRelaxed(__ex, __cnt);
	    }
	    catch(Ice.LocalException __ex)
	    {
		__cnt = __handleException(__ex, __cnt);
	    }
	}
    }

    public static HelloPrx
    checkedCast(Ice.ObjectPrx b)
    {
	HelloPrx d = null;
	if(b != null)
	{
	    try
	    {
		d = (HelloPrx)b;
	    }
	    catch(ClassCastException ex)
	    {
		if(b.ice_isA("::Demo::Hello"))
		{
		    HelloPrxHelper h = new HelloPrxHelper();
		    h.__copyFrom(b);
		    d = h;
		}
	    }
	}
	return d;
    }

    public static HelloPrx
    checkedCast(Ice.ObjectPrx b, java.util.Hashtable ctx)
    {
	HelloPrx d = null;
	if(b != null)
	{
	    try
	    {
		d = (HelloPrx)b;
	    }
	    catch(ClassCastException ex)
	    {
		if(b.ice_isA("::Demo::Hello", ctx))
		{
		    HelloPrxHelper h = new HelloPrxHelper();
		    h.__copyFrom(b);
		    d = h;
		}
	    }
	}
	return d;
    }

    public static HelloPrx
    checkedCast(Ice.ObjectPrx b, String f)
    {
	HelloPrx d = null;
	if(b != null)
	{
	    Ice.ObjectPrx bb = b.ice_newFacet(f);
	    try
	    {
		if(bb.ice_isA("::Demo::Hello"))
		{
		    HelloPrxHelper h = new HelloPrxHelper();
		    h.__copyFrom(bb);
		    d = h;
		}
	    }
	    catch(Ice.FacetNotExistException ex)
	    {
	    }
	}
	return d;
    }

    public static HelloPrx
    checkedCast(Ice.ObjectPrx b, String f, java.util.Hashtable ctx)
    {
	HelloPrx d = null;
	if(b != null)
	{
	    Ice.ObjectPrx bb = b.ice_newFacet(f);
	    try
	    {
		if(bb.ice_isA("::Demo::Hello", ctx))
		{
		    HelloPrxHelper h = new HelloPrxHelper();
		    h.__copyFrom(bb);
		    d = h;
		}
	    }
	    catch(Ice.FacetNotExistException ex)
	    {
	    }
	}
	return d;
    }

    public static HelloPrx
    uncheckedCast(Ice.ObjectPrx b)
    {
	HelloPrx d = null;
	if(b != null)
	{
	    HelloPrxHelper h = new HelloPrxHelper();
	    h.__copyFrom(b);
	    d = h;
	}
	return d;
    }

    public static HelloPrx
    uncheckedCast(Ice.ObjectPrx b, String f)
    {
	HelloPrx d = null;
	if(b != null)
	{
	    Ice.ObjectPrx bb = b.ice_newFacet(f);
	    HelloPrxHelper h = new HelloPrxHelper();
	    h.__copyFrom(bb);
	    d = h;
	}
	return d;
    }

    public static void
    __write(IceInternal.BasicStream __os, HelloPrx v)
    {
	__os.writeProxy(v);
    }

    public static HelloPrx
    __read(IceInternal.BasicStream __is)
    {
	Ice.ObjectPrx proxy = __is.readProxy();
	if(proxy != null)
	{
	    HelloPrxHelper result = new HelloPrxHelper();
	    result.__copyFrom(proxy);
	    return result;
	}
	return null;
    }
}
